import QtQuick 2.9

Flickable{
    id:flickable
    objectName: "flickable"

    interactive: true
    contentX: 0
    width: 489
    height: 480
    contentWidth: width
    contentHeight: height
    leftMargin: 408
    rightMargin :36
    maximumFlickVelocity: 0
    boundsBehavior: Flickable.StopAtBounds
    flickableDirection: Flickable.HorizontalFlick
    enabled: true

    PathView {
        id:pathView
        objectName: "pathView"

        property int countclick: 0

        readonly property int contentsWidth: 348
        readonly property int contentsHeight: 480

        y: 0
        width: contentsWidth
        height: contentsHeight

        interactive: true

        cacheItemCount: 10
        currentIndex: 2
        pathItemCount: 4
        highlightMoveDuration: 300
        highlightRangeMode : PathView.StrictlyEnforceRange
        preferredHighlightBegin: 0.5
        preferredHighlightEnd: 0.5
        snapMode : PathView.SnapOneItem
        dragMargin: 100

        onCurrentIndexChanged:{
            console.log("onCurrentIndexChanged");
            console.log(currentIndex);
        }

        // path設定
        // pathは切り替わるたびに、delegateに設定されたItem等が破棄・再生成されるため注意
        path: leftPath
        Path {
            id: leftPath
            startX: pathView.contentsWidth / 2 - 800
            startY: pathView.contentsHeight / 2 - 800

            PathArc {
                x: pathView.contentsWidth / 2 - 800
                y: pathView.contentsHeight / 2 + 800
                radiusX: 800
                radiusY: 800
                direction: PathArc.Clockwise
            }
        }

        ListModel {
            id: model
            ListElement { objectName:"aqua"; name: "aqua" ;mycolor:"aqua"}
            ListElement { objectName:"blue"; name: "blue" ;mycolor:"blue"}
            ListElement { objectName:"blueviolet"; name: "blueviolet" ;mycolor:"blueviolet"}
            ListElement { objectName:"brown"; name: "brown" ;mycolor:"brown"}
            ListElement { objectName:"chartreuse"; name: "chartreuse" ;mycolor:"chartreuse"}
        }
        model: model

        delegate: Item {
            id: revolveritem
            objectName: model.objectName

            width: pathView.contentsWidth
            height: pathView.contentsHeight

            Rectangle
            {
                id:myRectangle
                color: mycolor
                width: pathView.contentsWidth -20
                height: pathView.contentsHeight -20
            }
        }

        onMovementStarted: console.log("onMovementStart")
        onMovementEnded: console.log("onMovementEnded")
        onDragStarted: console.log("DragStart")
        onDragEnded: console.log("DragEnded")
        onFlickStarted: console.log("FlickStart")
        onFlickEnded: console.log("FlickEnded")
    }
}
